% vdp1.m
% integration de     dx/dt =  y + x - x**3   ,     dy/dt =  -x
%                          par un schema d Euler
% la solution exacte est l attracteur de Van der Pol
% fd, iacs, 18 septembre 2004, 2 janvier 2005, 22 janvier 2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('vdp1. Cycle limite non lineaire avec le schema d Euler.') ;
title ('Oscillateur de Van der Pol') ;
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
n=50;  dt=1/n
vec=zeros(2,2) ; 
x=0.1;
y=0;
% gset yrange[-1.1:1.1] ; gset xrange[-1.1: 1.1] ; 
% gset yrange[-1:1.3] ; gset xrange[-1: 1] ; 
axis ([ -1 , 1,  -1 , 1.3 ]) 
for i=1:6*n;
if i<=1 ;   hold off ; plot(x , y, '*g;depart;') ; end  ; 
px1 =    y + x - x**3    ; py1 =   - x  ; 
xn  = x + dt * px1       ; yn  = y + dt * py1 ;
%
vec(1,1)=x ; vec(2,1)=xn ; 
vec(1,2)=y ; vec(2,2)=yn ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'r;;') ; end ; 
x=xn ; y=yn ; 
end ; xn , yn 
hold on ;  plot(xn , yn , '*b;arrivee;') ; hold off ;
