% vdpco2.m
% integration de     dx/dt =  y + x - x**3 , dy/dt =  -x
% par les schemas d Euler expli, Euler impli et Crank-Nicolson
% la solution exacte est l attracteur de Van der Pol
% fd, iacs, 18 septembre 2004, 2, 16 janvier 2005, 22 janvier 2006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('Van Del Pol. Cycle limite non lineaire avec trois schemas.') ;
title ('Oscillateur de Van der Pol') ;
n=10;  dt=1/n
xe=zeros(2,1);
xe(1,1)=0.1  ;  xe(2,1)=0 ; xi=xe ; xcn=xe ; 
vece=zeros(2,2); veci=zeros(2,2); vecn=zeros(2,2);
% gset yrange[-0.7:1.5] ; gset xrange[-1: 1] ; 
axis ([ -1 , 1 ,  -.7 , 1.5 ]) 
for i=1:6*n;
if i<=1 ;   hold off ; plot( xe(1,1) , xe(2,1) , '*g;depart;') ; end  ; 
xne  = xe + dt * f(xe) ;   xni  = er(xi,dt) ;  xncn  = cn(xcn,dt) ;
vece(1,1)=xe(1,1) ; vece(2,1)=xne(1,1) ; 
vece(1,2)=xe(2,1) ; vece(2,2)=xne(2,1) ; 
veci(1,1)=xi(1,1) ; veci(2,1)=xni(1,1) ; 
veci(1,2)=xi(2,1) ; veci(2,2)=xni(2,1) ; 
vecn(1,1)=xcn(1,1) ; vecn(2,1)=xncn(1,1) ; 
vecn(1,2)=xcn(2,1) ; vecn(2,2)=xncn(2,1) ; 
hold on ; 
if i<=1 ; hold on ; 
plot ( vece(:,1) , vece(:,2), 'r;trajectoire expli;') ; 
plot ( veci(:,1) , veci(:,2), 'ob;trajectoire impli;') ; 
plot ( vecn(:,1) , vecn(:,2), 'og;trajectoire CN;') ; else ;
plot ( vece(:,1) , vece(:,2), 'r;;') ; 
plot ( veci(:,1) , veci(:,2), 'ob;;') ; 
plot ( vecn(:,1) , vecn(:,2), 'og;;') ; end ;
xe=xne ; xi=xni ;  xcn=xncn   ;  end ; 
plot ( xe(1,1) , xe(2,1), '*r;arrivee expli;')  ;
plot ( xi(1,1) , xi(2,1), '*b;arrivee impli;') ; 
plot ( xcn(1,1) , xcn(2,1), '*g;arrivee CN;') ; hold off ;
